<?php

namespace Mcnd\Event;

use Notes\Event\EventFetcher;
use Psr\Http\Message\ResponseFactoryInterface,
    Psr\Container\ContainerInterface,
    Psr\Http\Message\ResponseInterface,
    Psr\Http\Message\ServerRequestInterface,
    Psr\Http\Server\MiddlewareInterface,
    Psr\Http\Server\RequestHandlerInterface;

class EventMiddleware implements MiddlewareInterface
{
    public ContainerInterface $container;

    public EventManager $eventManager;

    public function __construct(ContainerInterface $container, EventManager $eventManager) {
        $this->container = $container;
        $this->eventManager = $eventManager;
    }

    public function process(ServerRequestInterface $request, RequestHandlerInterface $handler) : ResponseInterface
    {
        return $handler->handle($request);
    }

    public function fromAttributes(EventFetcher $fetcher) : self
    {
        foreach($fetcher->compile() as $event) {
            $this->eventManager->pushEvent($event);
        }

        return $this;
    }

    public function fromDefinition(EventDefinition $definition) : self
    {
        foreach($definition->list as $event) {
            $this->eventManager->eventRegister($event);
        }

        return $this;
    }
}
